import { ConstructFactoryGetInstanceProps, SsmEnvironmentEntriesGenerator } from '@aws-amplify/plugin-types';
import { StoragePrefix } from './types.js';
import { IBucket } from 'aws-cdk-lib/aws-s3';
import { StorageAccessDefinition } from './access_builder.js';
import { StorageAccessPolicyFactory } from './storage_access_policy_factory.js';
/**
 * Middleman between creating bucket policies and attaching those policies to corresponding roles
 */
export declare class StorageAccessPolicyArbiter {
    private readonly name;
    private readonly accessDefinition;
    private readonly ssmEnvironmentEntriesGenerator;
    private readonly getInstanceProps;
    private readonly bucket;
    private readonly storageAccessPolicyFactory;
    /**
     * Instantiate with context from the storage factory
     */
    constructor(name: string, accessDefinition: Record<StoragePrefix, StorageAccessDefinition[]>, ssmEnvironmentEntriesGenerator: SsmEnvironmentEntriesGenerator, getInstanceProps: ConstructFactoryGetInstanceProps, bucket: IBucket, storageAccessPolicyFactory?: StorageAccessPolicyFactory);
    /**
     * Responsible for creating bucket policies corresponding to the definition,
     * then invoking the corresponding ResourceAccessAcceptor to accept the policies
     */
    arbitratePolicies: () => void;
}
/**
 * This factory is really only necessary for allowing us to mock the BucketPolicyArbiter in tests
 */
export declare class StorageAccessPolicyArbiterFactory {
    getInstance: (name: string, accessDefinition: Record<StoragePrefix, StorageAccessDefinition[]>, ssmEnvironmentEntriesGenerator: SsmEnvironmentEntriesGenerator, getInstanceProps: ConstructFactoryGetInstanceProps, bucket: IBucket, bucketPolicyFactory?: StorageAccessPolicyFactory) => StorageAccessPolicyArbiter;
}
//# sourceMappingURL=storage_access_policy_arbiter.d.ts.map