import { IBucket } from 'aws-cdk-lib/aws-s3';
import { StorageAction } from './access_builder.js';
import { Policy } from 'aws-cdk-lib/aws-iam';
export type Permission = {
    actions: StorageAction[];
    resources: string[];
};
/**
 * Generates IAM policies scoped to a single bucket
 */
export declare class StorageAccessPolicyFactory {
    private readonly bucket;
    private readonly namePrefix;
    private readonly stack;
    private policyCount;
    /**
     * Instantiate with the bucket to generate policies for
     */
    constructor(bucket: IBucket);
    createPolicy: (permissions: Permission[]) => Policy;
    private getStatement;
}
//# sourceMappingURL=storage_access_policy_factory.d.ts.map