import { ConstructContainerEntryGenerator, ConstructFactoryGetInstanceProps, GenerateContainerEntryProps } from '@aws-amplify/plugin-types';
import { AmplifyStorage } from './construct.js';
import { StorageAccessPolicyArbiterFactory } from './storage_access_policy_arbiter.js';
import { AmplifyStorageFactoryProps } from './types.js';
import { RoleAccessBuilder } from './access_builder.js';
/**
 * Generates a single instance of storage resources
 */
export declare class StorageContainerEntryGenerator implements ConstructContainerEntryGenerator {
    private readonly props;
    private readonly getInstanceProps;
    private readonly bucketPolicyArbiterFactory;
    private readonly roleAccessBuilder;
    readonly resourceGroupName = "storage";
    /**
     * Initialize with context from storage factory
     */
    constructor(props: AmplifyStorageFactoryProps, getInstanceProps: ConstructFactoryGetInstanceProps, bucketPolicyArbiterFactory?: StorageAccessPolicyArbiterFactory, roleAccessBuilder?: RoleAccessBuilder);
    generateContainerEntry: ({ scope, ssmEnvironmentEntriesGenerator, }: GenerateContainerEntryProps) => AmplifyStorage;
}
//# sourceMappingURL=storage_container_entry_generator.d.ts.map